## libffts 14.1.0~r7-0debian7.0.0+pr1

=== debian/changelog ===
libffts (4:14.1.0~r7-0debian7.0.0+pr1) wheezy; urgency=medium

  * Automated git build for e4fcc7fd8faab801c98d972fe305aeed9b9d7790

 -- root <kb9vqf@pearsoncomputing.net>  Fri, 30 Sep 2016 20:20:52 +0000

libffts (0.1-0ubuntu0) karmic; urgency=low

  * Karmic rebuild

 -- Timothy Pearson <kb9vqf@pearsoncomputing.net>  Thu, 02 July 2009 16:08:00 -0600
