=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/simple-patchsys.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_CONFIGURE_INCLUDEDIR := /usr/include
DEB_CONFIGURE_MANDIR := /usr/share/man
DEB_CONFIGURE_PREFIX := /usr/
DEB_CONFIGURE_INFODIR := /usr/share/info

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(findstring x86_64-,$(DEB_BUILD_GNU_TYPE)))
	cdbs_configure_flags := --enable-single --enable-sse --enable-shared --disable-rpath
else ifneq (,$(findstring arm-,$(DEB_BUILD_GNU_TYPE)))
	cdbs_configure_flags := --enable-single --enable-neon --enable-shared --disable-rpath
else
	cdbs_configure_flags := --enable-single --enable-shared --disable-rpath
endif

DEB_DH_BUILDDEB_ARGS += -- -Z$(shell dpkg-deb --help | grep -q ":.* xz[,.]" \
                               && echo xz || echo bzip2)

post-patches:: debian/stamp-bootstrap

debian/stamp-bootstrap:
	! [ -f /usr/share/libtool/ltmain.sh ] || \
	cp -f /usr/share/libtool/ltmain.sh ltmain.sh
	! [ -f /usr/share/libtool/config/ltmain.sh ] || \
	cp -f /usr/share/libtool/config/ltmain.sh ltmain.sh
	autoreconf -i
	
	touch debian/stamp-bootstrap
