## libffts 14.1.0~r7-0debian8.0.0+pr1

=== debian/changelog ===
libffts (4:14.1.0~r7-0debian8.0.0+pr1) jessie; urgency=medium

  * Automated git build for e4fcc7fd8faab801c98d972fe305aeed9b9d7790

 -- root <kb9vqf@pearsoncomputing.net>  Fri, 30 Sep 2016 20:21:03 +0000
