## libffts 14.1.0~r18-0debian9.0.0+pr1

=== debian/changelog ===
libffts (4:14.1.0~r18-0debian9.0.0+pr1) stretch; urgency=medium

  * Automated git build for a7d7dbc5c401ccea3f19583b11ca59b4ec27b679

 -- root <kb9vqf@pearsoncomputing.net>  Sun, 02 Oct 2016 19:24:55 +0000
