=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,14 @@
 DEB_CONFIGURE_PREFIX := /usr/
 DEB_CONFIGURE_INFODIR := /usr/share/info
 
+# Honour "parallel=N" option of DEB_BUILD_OPTIONS.  Comment out to
+# never build in parallel, regardless of DEB_BUILD_OPTIONS.
+DEB_BUILD_PARALLEL = true
+
 DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
+DEB_DH_BUILDDEB_ARGS += -- -Z$(shell dpkg-deb --help | grep -q ":.* xz[,.]" \
+                               && echo xz || echo bzip2)
 
 ifneq (,$(findstring x86_64-,$(DEB_BUILD_GNU_TYPE)))
 	cdbs_configure_flags := --enable-single --enable-sse --enable-shared --disable-rpath
@@ -19,9 +26,6 @@
 	cdbs_configure_flags := --enable-single --enable-shared --disable-rpath
 endif
 
-DEB_DH_BUILDDEB_ARGS += -- -Z$(shell dpkg-deb --help | grep -q ":.* xz[,.]" \
-                               && echo xz || echo bzip2)
-
 post-patches:: debian/stamp-bootstrap
 
 debian/stamp-bootstrap:
@@ -30,5 +34,5 @@
 	! [ -f /usr/share/libtool/config/ltmain.sh ] || \
 	cp -f /usr/share/libtool/config/ltmain.sh ltmain.sh
 	autoreconf -i
-	
+
 	touch debian/stamp-bootstrap
