## libffts 14.1.2~r24-0debian8.0.0+pr1~raspbian

=== debian/changelog ===
libffts (4:14.1.2~r24-0debian8.0.0+pr1~raspbian) raspbian-jessie; urgency=medium

  * Automated git build for a08c8fe35d42ff5dceec1149460a23758edeede0

 -- root <kb9vqf@pearsoncomputing.net>  Mon, 21 Jan 2019 12:31:10 -0600
