=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,10 @@
 ifneq (,$(findstring x86_64-,$(DEB_BUILD_GNU_TYPE)))
 	cdbs_configure_flags := --enable-single --enable-sse --enable-shared --disable-rpath
 else ifneq (,$(findstring arm-,$(DEB_BUILD_GNU_TYPE)))
-	cdbs_configure_flags := --enable-single --enable-neon --enable-shared --disable-rpath
+ifneq(,$(findstring armhf,$(DEB_HOST_ARCH)))
+	cdbs_configure_flags := --enable-single --enable-neon --float_abi=hard --enable-shared --disable-rpath
+else ifneq (,$(findstring aarch64-,$(DEB_BUILD_GNU_TYPE)))
+	cdbs_configure_flags := --enable-single --enable-neon --float_abi=hard --enable-shared --disable-rpath
 else
 	cdbs_configure_flags := --enable-single --enable-shared --disable-rpath
 endif
