=== debian/control ===
Source: libffts
Section: libs
Priority: optional
Maintainer: Timothy Pearson <kb9vqf@pearsoncomputing.net>
Build-Depends: debhelper (>= 5), cdbs, automake, autoconf, libtool, libltdl-dev
Standards-Version: 3.8.4

Package: libffts
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Fastest Fourier Transform in the South shared library
 Shared objects for the Fastest Fourier Transform in the South
 .
 libffts contains the library of libffts.

Package: libffts-dev
Architecture: any
Depends: libffts (= ${binary:Version})
Description: The Fastest Fourier Transform in the South shared library
 Shared objects for the Fastest Fourier Transform in the South
 .
 libffts-dev contains development files and documentation.
