## libffts 14.1.2~r24-0ubuntu16.10.0+pr1

=== debian/changelog ===
libffts (4:14.1.2~r24-0ubuntu16.10.0+pr1) yakkety; urgency=medium

  * Automated git build for a08c8fe35d42ff5dceec1149460a23758edeede0

 -- root <kb9vqf@pearsoncomputing.net>  Mon, 21 Jan 2019 12:29:25 -0600
